local mod = RW:Boss("Emalon the Storm Watcher", "Vault of Archavon", "Vault of Archavon")
local L

mod.BossIcon = [[Interface\Icons\inv_misc_statue_10]]

---------------------------
-- Variables
local tNova, tNovaCD
local tOverchargeCD
local tBerserk
local wNova
local iOvercharge

---------------------------
-- Init

function mod:OnRegister()
	L = mod:RegisterLocale(self:GetName(), "enUS", true)
	if L then
		L.name = "Emalon the Storm Watcher"
	end
	L = mod:GetLocale()
	self.L = L
	
	self:SetTrigger(33993)
	self:SetWin()
	
	tNova = self:CastTimer(64216)
	tNovaCD = self:CDTimer(25, 64216, nil, nil, false)
	tOverchargeCD = self:CDTimer(45, 64218)
	tBerserk = self:BerserkTimer(360)
	
	wNova = self:RunawayWarning(64216)
	
	iOvercharge = self:Icon("SKULL", 64218, false)
end

---------------------------
-- Locals
local scanRepeat

---------------------------
-- Start

function mod:OnEngage(trigger)
	scanRepeat = 0

	self:Track("Nova", 64216, 65279)
	self:Track("Overcharge", 64218)

	tNovaCD:Start()
	tOverchargeCD:Start()
	tBerserk:Start()
end

function mod:Nova(event, args)
	if event == "SPELL_CAST_START" then
		tNova:Start()
		tNovaCD:Start()
		wNova:Show()
	end
end

local tguid
local function scanForHeal()
	local uID = mod:UIDFromGUID(tguid)
	if not uID then
		if scanRepeat < 5 then
			mod:Schedule("healScan", 0.4, scanForHeal)
			scanRepeat = scanRepeat + 1
		else
			scanRepeat = 0
		end
		return
	end
	iOvercharge:Show(tguid)
end

function mod:Overcharge(event, args)
	if event == "SPELL_CAST_SUCCESS" then
		tOverchargeCD:Start()
	
	elseif event == "SPELL_HEAL" then
		tguid = args.dGUID
		mod:Schedule("healScan", 0.2, scanForHeal)
	end
end
